package com.example.fieldagent

import android.app.Application
import android.content.Context
import com.example.fieldagent.utils.LocaleManager
import com.example.fieldagent.utils.PrefsManager
import dagger.hilt.android.HiltAndroidApp
import java.util.Locale
import javax.inject.Inject


@HiltAndroidApp
class AgentApplication : Application() {

    @Inject
    lateinit var prefsManager: PrefsManager


    @Inject
    lateinit var localeManager: LocaleManager

    override fun attachBaseContext(base: Context?) {
        val localeManager = LocaleManager()
        val supportedLanguages = listOf("en", "ar")
        val systemLang = Locale.getDefault().language
        val langToUse = if (systemLang in supportedLanguages) systemLang else "en"
        val newContext = localeManager.setLocale(base!!, langToUse)
        super.attachBaseContext(newContext)
    }
}