package com.example.fieldagent.data.apis

import com.example.fieldagent.data.models.responses.*

import com.example.fieldagent.data.network.responseUtil.ApiResponse
import okhttp3.MultipartBody
import okhttp3.RequestBody
import retrofit2.Call
import retrofit2.http.*

interface WebService {
    companion object {

        private const val LOGIN = "auth/login"
        private const val INSPECTIONS = "inspections"
        private const val DAMAGES = "damages"
        private const val RESTROOM_LIST = "restroom-conditions"
        private const val CATEGORY = "categories"
        private const val SELECT_CATEGORY = "categories"
        private const val USER = "users"



    }

    /*POST APIS*/
    @FormUrlEncoded
    @POST(LOGIN)
    fun login(@FieldMap hashMap: HashMap<String, Any>): Call<UserData>


    @GET(INSPECTIONS)
    fun inspectionsList(@QueryMap hashMap: Map<String, String>): Call<InspectionData>


    @Multipart
    @POST(INSPECTIONS)
    fun createInspections(@PartMap map: HashMap<String, RequestBody>): Call<SimpleResponseData>


    @GET(INSPECTIONS)
    fun damagesList(@QueryMap hashMap: Map<String, String>): Call<InspectionData>




    @Multipart
    @POST(DAMAGES)
    fun createDamage(@PartMap map: HashMap<String, RequestBody>,@Part images: List<MultipartBody.Part>): Call<SimpleResponseData>


    @DELETE("$INSPECTIONS/{id}")
    fun deleteInspections(@Path("id") id: String): Call<SimpleResponseData>

    @PUT("$INSPECTIONS/{id}")
    fun updateInspection(@Path("id") id: String): Call<ApiResponse<UserData>>


    @DELETE("$DAMAGES/{id}")
    fun deleteDamage(@Path("id") id: String): Call<SimpleResponseData>

    @Multipart
    @PUT("$DAMAGES/{id}")
    fun updateDamage(@Path("id") id: String,@PartMap map: HashMap<String, RequestBody>,@Part images: List<MultipartBody.Part>): Call<SimpleResponseData>


    @GET(RESTROOM_LIST)
    fun getRoomsList(): Call<RoomConditionData>

    @GET(CATEGORY)
    fun getCategoryList(): Call<ItemList>

    @GET(SELECT_CATEGORY)
    fun getSelectCategoryList(@QueryMap hashMap: Map<String, String>): Call<SelectCategoryData>


    @FormUrlEncoded
    @PUT("$USER/{id}")
    fun updateProfile(@Path("id") id: String,@FieldMap hashMap: HashMap<String, String>): Call<SimpleResponseData>

}