package com.example.fieldagent.ui.damagelist.adapter

import android.view.LayoutInflater
import android.view.ViewGroup
import androidx.recyclerview.widget.LinearLayoutManager
import androidx.recyclerview.widget.RecyclerView
import com.example.fieldagent.R
import com.example.fieldagent.data.models.responses.Damage
import com.example.fieldagent.databinding.DamageViewAdapterBinding
import com.example.fieldagent.ui.damagelist.DamageListFragment

class DamageListAdapter(val damageListFragment: DamageListFragment) : RecyclerView.Adapter<DamageListAdapter.DamageHolder>() {

    var mainList = ArrayList<Damage>()

    class DamageHolder(val binding: DamageViewAdapterBinding) : RecyclerView.ViewHolder(binding.root) {
        val recyclerView: RecyclerView = binding.rvImage

    }

    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int): DamageHolder {
        val binding = DamageViewAdapterBinding.inflate(LayoutInflater.from(parent.context), parent, false)
        return DamageHolder(binding)
    }

    override fun onBindViewHolder(holder: DamageHolder, position: Int) {
        val damage = mainList[position]

        val adapter = ShowImageAdapter(damage.images)
        holder.recyclerView.layoutManager = LinearLayoutManager(holder.itemView.context, LinearLayoutManager.HORIZONTAL, false)
        holder.recyclerView.adapter = adapter

        holder.binding.txtMain.text=damage.categoryName
        holder.binding.txtSub.text=damage.subcategoryName

        holder.binding.txtUnits.text=damage.unit
        holder.binding.txtItem.text = damage.itemQuantity.toString()
        holder.binding.txtValue.text = damage.itemValue.toString()
        val total = damage.itemValue * damage.itemQuantity

        holder.binding.txtTotal.text="$ "+total.toString()
        holder.binding.txtImage.text=damage.images?.size.toString()

        holder.binding.ivDelete.setOnClickListener {
            damageListFragment.clickDeleteItem(position,damage.id.toString())
        }
        holder.binding.txtDamage.setText(holder.binding.root.context.getString(R.string.damage)+" ${position+1}")

        holder.binding.ivEdit.setOnClickListener {
            damageListFragment.clickItem(position)
        }



    }

    fun submitList(list: ArrayList<Damage>) {
        mainList.clear()
        mainList.addAll(list)
        notifyDataSetChanged()
    }

    override fun getItemCount(): Int = mainList.size
}